# Rust编程指南

[为何创作本书](about.md)
[关于Rust语言](introduction.md)

## Getting started

- [牛刀小试](first-try/getting-started.md)
    - [安装Rust环境](first-try/installation.md)
    - [墙推VSCode!](first-try/editor.md)
    - [认识Cargo](first-try/cargo.md)
    - [你好，世界!](first-try/hello-world.md)

## Rust学习三部曲

- [基本概念](basic-rust/intro.md)
    - [变量与类型](basic-rust/variable-type.md)
    - [结构体、枚举](basic-rust/struct-enum.md)
    - [函数与方法](basic-rust/function-method.md)
    - [格式化输出](basic-rust/formatted-output.md)
    - [字符串、数组与切片](basic-rust/string-array-slice.md)
    - [流程控制](basic-rust/flow-control.md)
    - [返回、异常和错误](basic-rust/exception-error.md)
    - [模式匹配](basic-rust/match-pattern.md)
    - [文档注释](basic-rust/comment.md)
    - [包和模块](basic-rust/crate-module.md)
    
- [核心概念](core-concepts/intro.md)
    - [所有权](core-concepts/ownership.md)
    - [借用](core-concepts/borrowing.md)
    - [生命周期](core-concepts/lifetime.md)
    
- [进阶编程](advance-rust/intro.md)
    - [泛型](advance-rust/generitic.md)
    - [特征](advance-rust/trait.md)
    - [迭代器](advance-rust/interator.md)
    - [集合类型](advance-rust/collection.md)
    - [函数式编程](advance-rust/functional-programing.md)
    - [智能指针](advance-rust/smart-pointer.md)
    - [多线程](advance-rust/threads.md)
    - [测试](advance-rust/tests.md)
    - [错误处理](advance-rust/errors.md)
    - [宏](advance-rust/macro.md)

## 专题内容

- [代码风格](style-guide/intro.md)
    - [命名规范](style-guide/naming.md)
- [面向对象](object-oriented/intro.md)
    - [OO所需的特性](object-oriented/characteristics.md)
- [异步编程](async/intro.md)
    - [并发与并行](async/concurrency-parallelism.md)
- [Cargo详解](cargo/intro.md)
    - [配置参数](cargo/manifest.md)
- [性能调优](performance/intro.md)
    - [Benchmark性能测试](performance/benchmark.md)
- [Unsafe](unsafe/intro.md)
    - [原始指针](unsafe/raw-pointer.md)

- [宏编程](macro/intro.md)
    - [过程宏](macro/procedure-macro.md)


## 场景模版

- [场景示例](use-case/intro.md)